<?php

/**
 * MExpandDiv
 *
 * @author Jonas Guilherme Dahmer [jonas@solis.coop.br]
 *
 * @version $id$
 *
 * \b Maintainers: \n
 * Armando Taffarel Neto [taffarel@solis.coop.br]
 * Daniel Hartmann [daniel@solis.coop.br]
 *
 * @since
 * Creation date 2010/07/13
 *
 * \b Organization: \n
 * SOLIS - Cooperativa de Soluções Livres \n
 *
 * \b CopyRight: \n
 * Copyright (c) 2010 SOLIS - Cooperativa de Soluções Livres \n
 *
 * \b License: \n
 * Licensed under GPLv2 (for further details read the COPYING file or http://www.gnu.org/licenses/gpl.html)
 *
 * \b History: \n
 * See history in CVS repository: http://www.miolo.org.br
 *
 */
$MIOLO = MIOLO::getInstance();
$MIOLO->page->addScript('m_expanddiv.js');

class MExpandDiv extends MDiv 
{
    public function __construct($name, $content, $class = NULL, $attributes = NULL, $collapsedHeight = '16')
    {
        // Removes line breaks from the beginning and the end of the content
        // and then change them to <br />
        $content = nl2br( trim( (string) $content ) );

        $id = $name ? "{$name}box" : 'box' . rand();

        // Button to expand the div
        $expandButton = new MDiv("{$id}Button", '', 'mExpandDivButton mExpandDivButtonCollapsed');
        $expandButton->addEvent('click', "mexpanddiv.expand('{$id}', '{$collapsedHeight}');");

        // Div with the content
        $box = new MDiv($id, $content, 'mExpandDivText');
        $box->addStyle('height', "{$collapsedHeight}px");

        $div[] = new MDiv("{$id}Div", array( $expandButton, $box ));

        parent::__construct($name, $div, $class, $attributes);
    }
}
?>
