<?php

class frmValidators extends MForm
{
    public function __construct()
    {
        parent::__construct(_M('Validators Sample', MIOLO::getCurrentModule()));
        // creates a link to view the source
        $this->addField(new ViewSource(__FILE__));
    }

    public function createFields()
    {
        $module = MIOLO::getCurrentModule();

        $fields[] = new MTextField('tfRequired', 'value', _M('Required', $module), 20);
        $fields[] = new MTextField('tfMask', '12ab34cd', _M('Mask', $module), 20, '99aa99aa');
        $fields[] = new MTextField('tfEmail', 'a@miolo.ufjf.br', 'Email', 50);
        $fields[] = new MTextField('tfCep', '36100-000', 'CEP', 15);
        $fields[] = new MTextField('tfPhone', '333-3333', _M('Phone', $module), 15);
        $fields[] = new MTextField('tfTime', '12:12', _M('Time', $module), 15);
        $fields[] = new MTextField('tfCPF', '', 'CPF', 20);
        $fields[] = new MTextField('tfCNPJ', '', 'CNPJ', 20);
        $fields[] = new MTextField('tfDateDMY', '12/07/2003', _M('Date @1', $module, 'DMY'), 20);
        $fields[] = new MTextField('tfDateYMD', '2003/07/31', _M('Date @1', $module, 'YMD'), 20);
        $fields[] = new MTextField('tfCompare', '5', _M('Compare', $module), 5, ' >= 10');
        $fields[] = new MTextField('tfRange1', '5', _M('Integer Range', $module), 5, '[3..10]');
        $fields[] = new MTextField('tfRange2', 'cor', _M('String Range', $module), 20, '[a..f]');
        $fields[] = new MTextField('tfRange3', '12/07/2003', _M('Date Range', $module), 20, '[10/03/2003..05/10/2003]');

        // validator inline
        $fields[] = new MTextField('tfRegExp', 'teste@email.com', _M('Regular Expression', $module), 20,
                'email: [A-Za-z0-9_]+\@[A-Za-z0-9_]+\.[A-Za-z0-9_]+');
        $fields[] = new MTextField('tfInteger', '', _M('Integer', $module), 20, 'regexp: (^-?[0-9][0-9]*$)');
        $fields[] = new MTextField('tfInteger1', '0', _M('Integer', $module), 20);
        $fields[] = new MTextField('tfRequired1', 'ab123', _M('Mask', $module), 20, _M('Inserted on field creation', $module),
                new MMaskValidator('tfRequired1', '', 'aa999', 'required')
        );

        $validators[] = new MRequiredValidator('tfRequired');
        $validators[] = new MMaskValidator('tfMask', '', '99aa99aa', 'required');
        $validators[] = new MEmailValidator('tfEmail', '', 'required');
        $validators[] = new MCepValidator('tfCep', '', 'required');
        $validators[] = new MPhoneValidator('tfPhone', '', 'required');
        $validators[] = new MTimeValidator('tfTime', '', 'required');
        $validators[] = new MCPFValidator('tfCPF', '', 'optional');
        $validators[] = new MCNPJValidator('tfCNPJ', '', 'optional');
        $validators[] = new MDateDMYValidator('tfDateDMY', '', 'required');
        $validators[] = new MDateYMDValidator('tfDateYMD', '', 'required');
        $validators[] = new MCompareValidator('tfCompare', '', '>=', '10', 'i', 'required');
        $validators[] = new MRangeValidator('tfRange1', '', '3', '10', 'i', 'required');
        $validators[] = new MRangeValidator('tfRange2', '', 'a', 'f', 's', 'required');
        $validators[] = new MRangeValidator('tfRange3', '',
                '10/03/2003', '05/10/2003', 'd', 'required');
        $validators[] = new MRegExpValidator('tfRegExp', '',
                '[A-Za-z0-9_]+\@[A-Za-z0-9_]+\.[A-Za-z0-9_]+');
        $validators[] = new MRegExpValidator('tfInteger', '', '(^-?[0-9][0-9]*$)');
        $validators[] = new MIntegerValidator('tfInteger1', '', 'required');

        $buttons[] = new MBackButton();
        $buttons[] = new MButton('submit_button', _M('Submit', $module));

        $this->setFields($fields);
        $this->setValidators($validators);
        $this->setButtons($buttons);
    }
}
?>
