CREATE TABLE Curso ( 
       IdCurso                       INTEGER         NOT NULL PRIMARY KEY,
       Nome                          VARCHAR(100),
       IdSala                        INTEGER);

CREATE TABLE Aluno ( 
       IdAluno                       INTEGER         NOT NULL PRIMARY KEY,
       Nome                          VARCHAR(100),
       Sexo                          CHAR(1),
       Telefone                      CHAR(20),
       IdCurso                       INTEGER CONSTRAINT fk_Aluno_CursoId 
                                       REFERENCES Curso(IdCurso) 
);

CREATE TABLE Sala ( 
       IdSala                         INTEGER         NOT NULL PRIMARY KEY,
       Descricao                      VARCHAR(100));

CREATE TABLE cm_sequence ( 
       Sequence                      VARCHAR(30)         NOT NULL PRIMARY KEY,
       Value                         INTEGER);

CREATE SEQUENCE seq_curso MINVALUE 10;
CREATE SEQUENCE seq_aluno MINVALUE 300;
CREATE SEQUENCE seq_sala  MINVALUE 10;

-- INSERT INTO cm_sequence VALUES('seq_curso',4);
-- INSERT INTO cm_sequence VALUES('seq_aluno',207);
-- INSERT INTO cm_sequence VALUES('seq_sala',4);

insert into Sala values (1,'Sala 1');
insert into Sala values (2,'Sala 2');
insert into Sala values (3,'Sala 3');

insert into Curso values (1,'AdministraÃ§Ã£o',1);
insert into Curso values (2,'ComputaÃ§Ã£o',2);
insert into Curso values (3,'Medicina',3);

INSERT INTO Aluno VALUES(1,'IRENE DUARTE SOUZA','','',1);
INSERT INTO Aluno VALUES(2,'VALESCA NUNES DOS REIS','','',1);
INSERT INTO Aluno VALUES(3,'KELLI BORGES DOS SANTOS','','',1);
INSERT INTO Aluno VALUES(4,'FERNANDA MAZZONI DA COSTA','','',1);
INSERT INTO Aluno VALUES(5,'FABIO DA COSTA CARBOGIM','','',1);
INSERT INTO Aluno VALUES(6,'LUIS ALBERTO MONTIJO VASQUES','','',1);
INSERT INTO Aluno VALUES(7,'LUCIANE RIBEIRO','','',1);
INSERT INTO Aluno VALUES(8,'ANDREA CRISTINA DE ALMEIDA','','',1);
INSERT INTO Aluno VALUES(9,'LUZIANNE BENETTE FARAGE MOREIRA','','',1);
INSERT INTO Aluno VALUES(10,'ALESANDRO TEIXEIRA MORAES','','',1);
INSERT INTO Aluno VALUES(11,'RENATA SIQUEIRA JULIO','','',1);
INSERT INTO Aluno VALUES(12,'ALINE RIOS DE FREITAS','','',1);
INSERT INTO Aluno VALUES(13,'VERA NEUZA LEMOS','','',1);
INSERT INTO Aluno VALUES(14,'SUELI MEDINA VASCONCELOS SILVA','','',1);
INSERT INTO Aluno VALUES(15,'DEBORAH MIRANDA SERRAO','','',1);
INSERT INTO Aluno VALUES(16,'CAMILA TOLEDO DE SOUZA','','',1);
INSERT INTO Aluno VALUES(17,'ANNA ELISA SAD CAMPOS','','',1);
INSERT INTO Aluno VALUES(18,'DEBORA GOTARDELO AUDEBERT DELAGE','','',1);
INSERT INTO Aluno VALUES(19,'EDNEI MACHADO DE OLIVEIRA','','',1);
INSERT INTO Aluno VALUES(20,'PAULO SERGIO PINTO','','',1);
INSERT INTO Aluno VALUES(21,'GERALDO CESAR DOS SANTOS','','',1);
INSERT INTO Aluno VALUES(22,'ROSANGELA DE FATIMA DOS REIS','','',1);
INSERT INTO Aluno VALUES(23,'MARCELO JOSE DA COSTA','','',1);
INSERT INTO Aluno VALUES(24,'MARIA LUISA RIETRA MARZANO','','',1);
INSERT INTO Aluno VALUES(25,'HERICA SILVA DUTRA','','',1);
INSERT INTO Aluno VALUES(26,'ELIANE OLIVEIRA PINHEIRO','','',1);
INSERT INTO Aluno VALUES(27,'ANDREIA ZIMMERMANN','','',1);
INSERT INTO Aluno VALUES(28,'TANIA CONCOLATO GREGGIO','','',1);
INSERT INTO Aluno VALUES(29,'AMARILDO DE PAULA BATISTA','','',1);
INSERT INTO Aluno VALUES(30,'LEONARDO NEVES FONSECA','','',1);
INSERT INTO Aluno VALUES(31,'ANA CAROLINA MARQUES CODOGNOTTO','','',1);
INSERT INTO Aluno VALUES(32,'IRLA SAAR RIBEIRO CERQUEIRA','','',1);
INSERT INTO Aluno VALUES(33,'ELENIR PEREIRA DE PAIVA','','',1);
INSERT INTO Aluno VALUES(34,'POLLYANNA FAITANIN','','',1);
INSERT INTO Aluno VALUES(35,'ALESSANDRA TASSI DE PAULA','','',1);
INSERT INTO Aluno VALUES(36,'RENATA CRISTINA CONDE','','',1);
INSERT INTO Aluno VALUES(37,'MARGARETE MOREIRA COUTINHO','','',1);
INSERT INTO Aluno VALUES(38,'WAGNER JAERNEVAY SILVEIRA','','',1);
INSERT INTO Aluno VALUES(39,'DANIELA DE MELO ALVIM MACHADO','','',1);
INSERT INTO Aluno VALUES(40,'ALESSANDRA DE SOUZA GOMES ALMEIDA','','',1);
INSERT INTO Aluno VALUES(41,'JOELMA ELIZABETH PORTES DOS REIS','','',1);
INSERT INTO Aluno VALUES(42,'RAQUEL DE SOUZA LIMA','','',1);
INSERT INTO Aluno VALUES(43,'VIVIANE DE SOUZA MACHADO','','',1);
INSERT INTO Aluno VALUES(44,'MELISSA TERESINHA NASCIMENTO LOPES','','',1);
INSERT INTO Aluno VALUES(45,'VANDER LUCIO TAFURI AMARAL','','',1);
INSERT INTO Aluno VALUES(46,'PAULO SERGIO GOMES DE OLIVEIRA','','',1);
INSERT INTO Aluno VALUES(47,'MARIA DO SOCORRO LINA VAN KEULEN','','',1);
INSERT INTO Aluno VALUES(48,'LIVIA GOMES DA SILVA','','',1);
INSERT INTO Aluno VALUES(49,'LECIANA DE OLIVEIRA LAMBERT','','',1);
INSERT INTO Aluno VALUES(50,'FABRICIO LUIS DA SILVA','','',1);
INSERT INTO Aluno VALUES(51,'REJANE DA CUNHA VIEIRA','','',1);
INSERT INTO Aluno VALUES(52,'GIANNI PIRES DUQUE SALES','','',1);
INSERT INTO Aluno VALUES(53,'ELAINE ARAUJO SILVA','','',1);
INSERT INTO Aluno VALUES(54,'REJANE RODRIGUES RIBEIRO','','',1);
INSERT INTO Aluno VALUES(55,'RENATA HELOISA DE CERQUEIRA','','',1);
INSERT INTO Aluno VALUES(56,'PRISCILA FERNANDA NERY DE SOUZA','','',1);
INSERT INTO Aluno VALUES(57,'MARCILIA DE FATIMA VILELA PAULA FONSECA','','',1);
INSERT INTO Aluno VALUES(58,'JOSE RICARDO RIBEIRO RAPOSO','','',1);
INSERT INTO Aluno VALUES(59,'LEONARDO SANTANA ROCHA','','',1);
INSERT INTO Aluno VALUES(60,'BRUNA PINHEIRO PASCOTTO','','',1);
INSERT INTO Aluno VALUES(61,'ARUANA ANDRADE DE MAGALHAES SCOFIELD','','',1);
INSERT INTO Aluno VALUES(62,'MARIA APARECIDAD GUEDES COUTO','','',1);
INSERT INTO Aluno VALUES(63,'JOSE AUGUSTO MELADO','','',1);
INSERT INTO Aluno VALUES(64,'DILENE MARIA SANTIAGO FERRARI','','',1);
INSERT INTO Aluno VALUES(65,'KATIA APARECIDA PEDRETTI','','',1);
INSERT INTO Aluno VALUES(66,'LUCIANE APARECIDA SANDI','','',1);
INSERT INTO Aluno VALUES(67,'CHRISTIANNY CORREA GHIRLINZONI','','',1);
INSERT INTO Aluno VALUES(68,'ALINE APARECIDA BERNO','','',1);
INSERT INTO Aluno VALUES(69,'KATIA PACHECO PERENSIM','','',1);
INSERT INTO Aluno VALUES(70,'ALESSANDRA CAMPOS CIMINO','','',1);
INSERT INTO Aluno VALUES(71,'KELLEN TELES LOPES','','',1);
INSERT INTO Aluno VALUES(72,'ROGINNER FERNANDO MOREIRA CRISTIANO','','',1);
INSERT INTO Aluno VALUES(73,'MELINA PEREIRA FARIA','','',1);
INSERT INTO Aluno VALUES(74,'KELY CRISTINE BATISTA','','',1);
INSERT INTO Aluno VALUES(75,'ELOIZA AUGUSTA GOMES','','',1);
INSERT INTO Aluno VALUES(76,'SILVIA ALVES DE OLIVEIRA','','',1);
INSERT INTO Aluno VALUES(77,'MARIA TEREZA AGUIAR CASTILHO NETA','','',1);
INSERT INTO Aluno VALUES(78,'CARLOS ALEXANDRE CARNEIRO LELIS','','',1);
INSERT INTO Aluno VALUES(79,'MARGARETH ALVES MENEZES','','',1);
INSERT INTO Aluno VALUES(80,'ADRIANA LUISA ZIGLER DE OLIVEIRA','','',2);
INSERT INTO Aluno VALUES(81,'ALINE FARIA CRUZ','','',2);
INSERT INTO Aluno VALUES(82,'MICHELI MOREIRA EGYDIO','','',2);
INSERT INTO Aluno VALUES(83,'ROBERTA LOPES MARQUES','','',2);
INSERT INTO Aluno VALUES(84,'ROSANGELA APARECIDA ELERATI SILVA','','',2);
INSERT INTO Aluno VALUES(85,'DAISE LUCIDE BARBOSA','','',2);
INSERT INTO Aluno VALUES(86,'MICHELE STHERLING','','',2);
INSERT INTO Aluno VALUES(87,'AMANDA DE SOUZA SANTOS','','',2);
INSERT INTO Aluno VALUES(88,'EDILEIA LIMA DE AQUINO','','',2);
INSERT INTO Aluno VALUES(89,'GISELE DE PAULA ABRAHAO','','',2);
INSERT INTO Aluno VALUES(90,'FERNANDA DE VASCONCELOS FREIRE','','',2);
INSERT INTO Aluno VALUES(91,'TERESA CRISTINA SILVA PALERMO','','',2);
INSERT INTO Aluno VALUES(92,'MARCILENE CHAVES COSTA','','',2);
INSERT INTO Aluno VALUES(93,'EDILENI RODRIGUES SILVA GONDIM SIMAO','','',2);
INSERT INTO Aluno VALUES(94,'ROBERTA FERREIRA SCHAEFER','','',2);
INSERT INTO Aluno VALUES(95,'ROBERTA TEIXEIRA PRADO','','',2);
INSERT INTO Aluno VALUES(96,'MARIA LUIZA MAGALHAES DE OLIVEIRA BALDIOTI','','',2);
INSERT INTO Aluno VALUES(97,'MARIA DE FATIMA VIEIRA','','',2);
INSERT INTO Aluno VALUES(98,'VANIA MARIA DOS SANTOS MATOS','','',2);
INSERT INTO Aluno VALUES(99,'LUCINEIME DO CARMO DE JESUS','','',2);
INSERT INTO Aluno VALUES(100,'NILZA ROCHA DE SOUZA','','',2);
INSERT INTO Aluno VALUES(101,'PATRICIA RODRIGUES MARTINS','','',2);
INSERT INTO Aluno VALUES(102,'FERNANDA CRISTINA ZIMMERMANN FRANCO','','',2);
INSERT INTO Aluno VALUES(103,'MONICA OLIVEIRA FERREIRA','','',2);
INSERT INTO Aluno VALUES(104,'TEREZINHA APARECIDA VIEIRA','','',2);
INSERT INTO Aluno VALUES(105,'VIRGINIA CARLOS DOS REIS','','',2);
INSERT INTO Aluno VALUES(106,'MARA LUCIA WELERSON SOTT DALDEGAN','','',2);
INSERT INTO Aluno VALUES(107,'ANA LUCIA DE ANDRADE','','',2);
INSERT INTO Aluno VALUES(108,'GENEZIELLY RAPOSO FERREIRA','','',1);
INSERT INTO Aluno VALUES(109,'ALYNE SCHREIDER','','',1);
INSERT INTO Aluno VALUES(110,'FABIANA FERREIRA DE MELLO','','',1);
INSERT INTO Aluno VALUES(111,'FLAVIA CRISTINA DUARTE SILVA','','',1);
INSERT INTO Aluno VALUES(112,'JULIANA DA ROCHA REIS','','',1);
INSERT INTO Aluno VALUES(113,'CATARINA DORNELAS','','',1);
INSERT INTO Aluno VALUES(114,'LUCILEIA LINO NEPOMUCENO','','',1);
INSERT INTO Aluno VALUES(115,'PAULA MORAES REZENDE','','',1);
INSERT INTO Aluno VALUES(116,'MARCELO LEITE DE PAULA BATISTA','','',1);
INSERT INTO Aluno VALUES(117,'KECIA FABIANA ANTUNES MAURICIO','','',1);
INSERT INTO Aluno VALUES(118,'CAMILA MESSIAS RAMOS','','',1);
INSERT INTO Aluno VALUES(119,'TATIANA NATALINA SEVIDANES BOUSADA','','',1);
INSERT INTO Aluno VALUES(120,'SANISE LIVIA CARDOSO','','',1);
INSERT INTO Aluno VALUES(121,'DANIELE COSTA DE CARVALHO','','',1);
INSERT INTO Aluno VALUES(122,'ELIANA LIGIA CARVALHO CERUTTI PEREIRA','','',1);
INSERT INTO Aluno VALUES(123,'VALERIA CHIAVEGATTO CAMPOS MUNIZ','','',1);
INSERT INTO Aluno VALUES(124,'ALESSANDRA FERNANDES RIBEIRO','','',1);
INSERT INTO Aluno VALUES(125,'JAQUELINE VIEIRA AGUIAR','','',1);
INSERT INTO Aluno VALUES(126,'MARCIA MIYUKI AMANUMA FRANCO DE OLIVEIRA','','',1);
INSERT INTO Aluno VALUES(127,'RITA APARECIDA GUEDES MATTOSINHOS','','',1);
INSERT INTO Aluno VALUES(128,'FATIMA MARIA CHAMHUM DE ALMEIDA PAULA','','',1);
INSERT INTO Aluno VALUES(129,'APARECIDA REGIANE GIRON','','',1);
INSERT INTO Aluno VALUES(130,'MARIA JOSE LOPES D A SILVA','','',1);
INSERT INTO Aluno VALUES(131,'CRISTINA ROCHA AMARAL','','',1);
INSERT INTO Aluno VALUES(132,'LUCIMARA KELLY DE CASTRO','','',1);
INSERT INTO Aluno VALUES(133,'ELIEZER SILVA DE LACERDA','','',1);
INSERT INTO Aluno VALUES(134,'ELAINE CRISTINA SANTOS BARBOSA','','',1);
INSERT INTO Aluno VALUES(135,'RONYLLA RODRIGUES GANDA','','',1);
INSERT INTO Aluno VALUES(136,'FERNANDA G F MENDONCA','','',1);
INSERT INTO Aluno VALUES(137,'SABRINA VIEIRA CENTELLAS','','',1);
INSERT INTO Aluno VALUES(138,'ALINE DANIELLE DA SILVEIRA','','',1);
INSERT INTO Aluno VALUES(139,'KATIA DE LANDA MORAES','','',1);
INSERT INTO Aluno VALUES(140,'CELIA REGINA PAIS DE OLIVEIRA','','',1);
INSERT INTO Aluno VALUES(141,'INES RODRIGUES DE SOUZA','','',1);
INSERT INTO Aluno VALUES(142,'ROSANGELA DE ANDRADE CARDOSO VICENTE','','',1);
INSERT INTO Aluno VALUES(143,'MAYLA ELISA CRUZ','','',1);
INSERT INTO Aluno VALUES(144,'BIANCA RIBEIRO MENDES MONTES','','',1);
INSERT INTO Aluno VALUES(145,'EDILENE COSTA DUARTE DE ANDRADE','','',1);
INSERT INTO Aluno VALUES(146,'ANA CAROLINA AMARAL DE SAO JOSE','','',1);
INSERT INTO Aluno VALUES(147,'VIVIAN LOUISE MANULLI LESSA','','',1);
INSERT INTO Aluno VALUES(148,'EDICY ELISA RENAULT MACHADO','','',1);
INSERT INTO Aluno VALUES(149,'GISELLE BANDEIRA DE OLIVEIRA','','',1);
INSERT INTO Aluno VALUES(150,'MARILENE VARGAS DA SILVA','','',1);
INSERT INTO Aluno VALUES(151,'MARIA CAMILA FERREIRA NUNES','','',1);
INSERT INTO Aluno VALUES(152,'LUCIA HELENA NOVELLINO PEREIRA','','',1);
INSERT INTO Aluno VALUES(153,'VIVIANE NUNES DE PAULA','','',1);
INSERT INTO Aluno VALUES(154,'MICHELLE RODRIGUES DE AMORIM','','',1);
INSERT INTO Aluno VALUES(155,'VALDILANE APARECIDA NUNES DE MOURA','','',1);
INSERT INTO Aluno VALUES(156,'GLAUCO MENDONCA ROCHA','','',1);
INSERT INTO Aluno VALUES(157,'CINARA GOMES ALEIXO','','',1);
INSERT INTO Aluno VALUES(158,'CLAUDIA GUILHERME FAGUNDES BELLO','','',1);
INSERT INTO Aluno VALUES(159,'WILLENA BRAGA D`APPARECIDA','','',1);
INSERT INTO Aluno VALUES(160,'LILIANE SILVA MARTINS','','',1);
INSERT INTO Aluno VALUES(161,'ROSIMERE APARECIDA DA SILVEIRA','','',1);
INSERT INTO Aluno VALUES(162,'LUCIANA DO NASCIMENTO CAMPISSI','','',1);
INSERT INTO Aluno VALUES(163,'THANIA MARIA CARVALHO DAMASCENO','','',1);
INSERT INTO Aluno VALUES(164,'LILIAN BARBOSA DE SOUZA','','',1);
INSERT INTO Aluno VALUES(165,'FABRICIO VIEIRA','','',1);
INSERT INTO Aluno VALUES(166,'ELAINE DUTRA FIALHO','','',1);
INSERT INTO Aluno VALUES(167,'RAFAELA LUCIA COELHO DOS SANTOS','','',1);
INSERT INTO Aluno VALUES(168,'MAURICIO VIANNA DA COSTA','','',1);
INSERT INTO Aluno VALUES(169,'RACHEL MONTEIRO JUNQUEIRA','','',1);
INSERT INTO Aluno VALUES(170,'LILIANE ALVES DA ROCHA RANGEL','','',1);
INSERT INTO Aluno VALUES(171,'JANE EIRE URZEDO','','',1);
INSERT INTO Aluno VALUES(172,'ANA REGINA BORGES','','',1);
INSERT INTO Aluno VALUES(173,'RENATA ALMEIDA DE MATOS','','',1);
INSERT INTO Aluno VALUES(174,'ROSILENE DO CARMO SIQUEIRA','','',1);
INSERT INTO Aluno VALUES(175,'ALESSANDRA GOMES SILVA','','',1);
INSERT INTO Aluno VALUES(176,'MARIA APARECIDA FACHINI SPADA','','',1);
INSERT INTO Aluno VALUES(177,'SANDRA LUCIA DA ROCHA DANIEL','','',1);
INSERT INTO Aluno VALUES(178,'LUIS FERNANDO DA SILVA ALVES','','',1);
INSERT INTO Aluno VALUES(179,'VERONICA MATILDE DA CONCEICAO','','',1);
INSERT INTO Aluno VALUES(180,'LIVIA MARIA DE AZEVEDO FRANCO','','',1);
INSERT INTO Aluno VALUES(181,'SIDNEY SOUSA AUGUSTO','','',1);
INSERT INTO Aluno VALUES(182,'MONICA CECILIA GOULART DE OLIVEIRA','','',1);
INSERT INTO Aluno VALUES(183,'ELIS REGINA DE OLIVEIRA','','',1);
INSERT INTO Aluno VALUES(184,'FERNANDA RIBEIRO DE ANDRADE','','',1);
INSERT INTO Aluno VALUES(185,'AMANDA CAMPOS SOUZA','','',1);
INSERT INTO Aluno VALUES(186,'PATRICIA DO CARMO MELLO','','',1);
INSERT INTO Aluno VALUES(187,'MARLUCI DE OLIVEIRA','','',1);
INSERT INTO Aluno VALUES(188,'RUI CARLOS ROCHA','','',1);
INSERT INTO Aluno VALUES(189,'DEUZIMAR SILVEIRA DE MELLO OLIVEIRA','','',3);
INSERT INTO Aluno VALUES(190,'FRANCIANE DE OLIVEIRA MARTINS','','',3);
INSERT INTO Aluno VALUES(191,'TAMARA FERREIRA BARBOSA','','',3);
INSERT INTO Aluno VALUES(192,'IZAURA RAIMUNDA TEIXEIRA LAUDEANO','','',3);
INSERT INTO Aluno VALUES(193,'CAROLINA XAVIER DO NASCIMENTO','','',3);
INSERT INTO Aluno VALUES(194,'ROSANE RODRIGUES DE CASTRO','','',3);
INSERT INTO Aluno VALUES(195,'SILVIA RAQUEL PERES TOLEDO','','',3);
INSERT INTO Aluno VALUES(196,'MARIA AUXILIADOR PADULA','','',3);
INSERT INTO Aluno VALUES(197,'ROBERTA APARECIDA DAVILA MOTTA','','',3);
INSERT INTO Aluno VALUES(198,'DENISE MARIA LESSA DE LIMA','','',3);
INSERT INTO Aluno VALUES(199,'APARECIDA FATIMA DE OLIVEIRA','','',3);
INSERT INTO Aluno VALUES(200,'DELMAR TEIXEIRA GOMES','','',3);
INSERT INTO Aluno VALUES(201,'SANDRO HENRIQUE GUEDES MENDONCA','','',3);
INSERT INTO Aluno VALUES(202,'LILIANE CRISTINA REZENDE FERREIRA','','',3);
INSERT INTO Aluno VALUES(203,'ANA CLAUDIA ESTEVES PEREIRA BASTOS','','',3);
INSERT INTO Aluno VALUES(204,'RILSE MARA HERONDINO','','',3);
INSERT INTO Aluno VALUES(205,'CRISTINA DE SOUZA MONTES','','',3);
INSERT INTO Aluno VALUES(206,'VALTER ADRIANO PAULINO DE CAMPOS','','',3);
